<?php

/**
 * 
 * Subclase que representa una fila de la tabla 'feeds'.
 * 
 *
 * @package lib.model
 */ 
 
require_once(dirname(__FILE__).'/../../apps/feedo/lib/magpie/rss_fetch.inc');
 
class Feeds extends BaseFeeds
{
/**
 * 
 * Almacena el retorno de fetch_rss.
 * @var string 
 * 
 */  
  var $rss;
/**
 * 
 * Retorna el t&iacute;tulo del feed.
 * @return string 
 * 
 */
	public function getTitle()
	{
		$rss = fetch_rss($this->getUrl());
		if(!isset($rss))
		{
			return null;
		}
		else
		{
			return @utf8_encode($rss->channel['title']);
		}
	}
/**
 * 
 * Retorna la cadena de texto 'S&iacute;' si el feed se encuentra entre los recomendados
 * por el administrador del sistema. Retorna la cadena 'No' en caso contrario. 
 * @return string
 * 
 */	
	public function getIsProposed()
	{
		if($this->getRecomendado() == 0)
		{
			return 'No';
		}
		else
		{
			return 'S&iacute;';
		}
	}
/**
 * 
 * Apunta en la base de datos el feed como recomendado o no recomendado por el administrador del sistema.
 * Si se marca como recomendado y ningun usuario lo tiene agregado se borra.
 * 
 */	
	public function setIsProposed()
	{
		$par = sfContext::getInstance()->getRequest()->getParameter('feeds[is_proposed]');
		if($par == 'Si')
			$this->setRecomendado(1);
		if($par == 'No')
		{
			$this->setRecomendado(0);
		}	
	}
/**
 * 
 * Retorna cierto si el feed se encuentra disponible.
 * @return bool  
 * 
 */
  public function isAvailable()
  {
	if($rss = fetch_rss($this->getUrl()))
	{
		return true;
	}
	else
	{
		return false;
	}
	
  }
}
