<?php

/**
 * 
 * Subclase que representa una fila de la tabla 'feeds_sistema'.
 * 
 *
 * @package lib.model
 */ 

require_once(dirname(__FILE__).'/../../apps/feedo/lib/magpie/rss_fetch.inc');
 
class FeedsSistema extends BaseFeedsSistema
{
/**
 * 
 * Almacena el retorno de fetch_rss.
 * @var string 
 * 
 */  
  var $rss;
/**
 * 
 * Retorna cierto si el feed se encuentra disponible.
 * @return bool  
 * 
 */
  public function isAvailable()
  {
	if($rss = fetch_rss($this->getUrl()))
	{
		return true;
	}
	else
	{
		return false;
	}
	
  }
/**
 * 
 * Retorna el t&iacute;tulo del feed.
 * @return string   
 * 
 */ 
  public function getTitle()
  {
	$rss = fetch_rss($this->getUrl());
	if(!isset($rss))
	{
		return null;
	}
	else
	{
		return @utf8_encode($rss->channel['title']);
	}
  }
/**
 * 
 * Retorna un string con la URL de la fuente RSS.
 * @return string
 * 
 */
  public function getLink()
  {
    $rss = fetch_rss($this->getUrl());
	if(!isset($rss))
	{
		return null;
	}
	else
	{
		return $rss->channel['link'];
	}
  }
/**
 * 
 * Retorna un array con los titulares y los enlaces del feed. La claves del array
 * son los enlaces y los valores los titulares.
 * @return array('string'=>'string')
 * 
 */
  public function getItems()
  {
	$length = $this->getNumeroEntradas();
    $rss = fetch_rss($this->getUrl());
	for($i = 0; $i < $length; $i++)
	{
		$items[$rss->items[$i]['link']] = utf8_encode($rss->items[$i]['title']);
	}
	return $items;
  }
/**
 * 
 * Retorna la URL del rss almacenada en la base de datos cuando se sindic&oacute; el canal.
 * @return string
 * 
 */
  public function getUrl()
  {
	$feed = FeedsPeer::retrieveByPk($this->getFeedsId());
	return $feed->getUrl();
  }
/**
 * 
 * Retorna el n&uacute;mero de titulares a mostrar de la configuraci&oacute;n del feed.
 * @return int
 * 
 */  
  public function getNumeroEntradas()
  {
	$conf_feed = ConfFeedPeer::retrieveByPk($this->getConfFeedId());
	return $conf_feed->getNumeroEntradas();
  }
/**
 * 
 * Retorna la descripci&oacute;n de la categor&iacute;a a la que pertenece el feed.
 * @return int 
 * 
 */  
  public function getCategoria()
  {
	return CategoriasPeer::retrieveByPk($this->getCategoriasId())->getDescripcion();
  }
/**
 * 
 * Retorna cierto si la URL ha sido una de las &uacute;ltimas 200 URLs visitadas por el usuario.
 * @param string $id_usuario Usuario del que se pretenda saber si visit&oacute; la URL o no.
 * @param string $url URL de la que se determinar&aacute; si ha sido visitada o no. 
 * @return bool
 * 
 */  
  public function isVisited($id_usuario,$url)
  {
	$c = new Criteria();
	$c->addJoin(UrlVisitadasUsuarioPeer::ID_URL,UrlVisitadasPeer::ID_URL);
	$c->add(UrlVisitadasPeer::URL, $url);
	$c->add(UrlVisitadasUsuarioPeer::ID_USUARIO, $id_usuario);
	$aux = UrlVisitadasUsuarioPeer::doSelect($c);
	if(!$aux)
	{
		return false;
	}
	else
		return true;
  }
  
}
