<?php


abstract class BaseCategorias extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id_categoria;


	
	protected $descripcion = 'null';


	
	protected $sistema = 0;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getIdCategoria()
	{

		return $this->id_categoria;
	}

	
	public function getDescripcion()
	{

		return $this->descripcion;
	}

	
	public function getSistema()
	{

		return $this->sistema;
	}

	
	public function setIdCategoria($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_categoria !== $v) {
			$this->id_categoria = $v;
			$this->modifiedColumns[] = CategoriasPeer::ID_CATEGORIA;
		}

	} 
	
	public function setDescripcion($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->descripcion !== $v || $v === 'null') {
			$this->descripcion = $v;
			$this->modifiedColumns[] = CategoriasPeer::DESCRIPCION;
		}

	} 
	
	public function setSistema($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->sistema !== $v || $v === 0) {
			$this->sistema = $v;
			$this->modifiedColumns[] = CategoriasPeer::SISTEMA;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id_categoria = $rs->getInt($startcol + 0);

			$this->descripcion = $rs->getString($startcol + 1);

			$this->sistema = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Categorias object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CategoriasPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CategoriasPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CategoriasPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CategoriasPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setIdCategoria($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CategoriasPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = CategoriasPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CategoriasPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdCategoria();
				break;
			case 1:
				return $this->getDescripcion();
				break;
			case 2:
				return $this->getSistema();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CategoriasPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdCategoria(),
			$keys[1] => $this->getDescripcion(),
			$keys[2] => $this->getSistema(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CategoriasPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdCategoria($value);
				break;
			case 1:
				$this->setDescripcion($value);
				break;
			case 2:
				$this->setSistema($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CategoriasPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdCategoria($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescripcion($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setSistema($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CategoriasPeer::DATABASE_NAME);

		if ($this->isColumnModified(CategoriasPeer::ID_CATEGORIA)) $criteria->add(CategoriasPeer::ID_CATEGORIA, $this->id_categoria);
		if ($this->isColumnModified(CategoriasPeer::DESCRIPCION)) $criteria->add(CategoriasPeer::DESCRIPCION, $this->descripcion);
		if ($this->isColumnModified(CategoriasPeer::SISTEMA)) $criteria->add(CategoriasPeer::SISTEMA, $this->sistema);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CategoriasPeer::DATABASE_NAME);

		$criteria->add(CategoriasPeer::ID_CATEGORIA, $this->id_categoria);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getIdCategoria();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setIdCategoria($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescripcion($this->descripcion);

		$copyObj->setSistema($this->sistema);


		$copyObj->setNew(true);

		$copyObj->setIdCategoria(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CategoriasPeer();
		}
		return self::$peer;
	}

} 