<?php


abstract class BaseFeeds extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id_feed;


	
	protected $url = 'null';


	
	protected $recomendado = 0;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getIdFeed()
	{

		return $this->id_feed;
	}

	
	public function getUrl()
	{

		return $this->url;
	}

	
	public function getRecomendado()
	{

		return $this->recomendado;
	}

	
	public function setIdFeed($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_feed !== $v) {
			$this->id_feed = $v;
			$this->modifiedColumns[] = FeedsPeer::ID_FEED;
		}

	} 
	
	public function setUrl($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->url !== $v || $v === 'null') {
			$this->url = $v;
			$this->modifiedColumns[] = FeedsPeer::URL;
		}

	} 
	
	public function setRecomendado($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->recomendado !== $v || $v === 0) {
			$this->recomendado = $v;
			$this->modifiedColumns[] = FeedsPeer::RECOMENDADO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id_feed = $rs->getInt($startcol + 0);

			$this->url = $rs->getString($startcol + 1);

			$this->recomendado = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Feeds object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedsPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			FeedsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedsPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FeedsPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setIdFeed($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += FeedsPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = FeedsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdFeed();
				break;
			case 1:
				return $this->getUrl();
				break;
			case 2:
				return $this->getRecomendado();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdFeed(),
			$keys[1] => $this->getUrl(),
			$keys[2] => $this->getRecomendado(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdFeed($value);
				break;
			case 1:
				$this->setUrl($value);
				break;
			case 2:
				$this->setRecomendado($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdFeed($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUrl($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setRecomendado($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(FeedsPeer::DATABASE_NAME);

		if ($this->isColumnModified(FeedsPeer::ID_FEED)) $criteria->add(FeedsPeer::ID_FEED, $this->id_feed);
		if ($this->isColumnModified(FeedsPeer::URL)) $criteria->add(FeedsPeer::URL, $this->url);
		if ($this->isColumnModified(FeedsPeer::RECOMENDADO)) $criteria->add(FeedsPeer::RECOMENDADO, $this->recomendado);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FeedsPeer::DATABASE_NAME);

		$criteria->add(FeedsPeer::ID_FEED, $this->id_feed);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getIdFeed();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setIdFeed($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUrl($this->url);

		$copyObj->setRecomendado($this->recomendado);


		$copyObj->setNew(true);

		$copyObj->setIdFeed(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FeedsPeer();
		}
		return self::$peer;
	}

} 