<?php


abstract class BaseFeedsSistema extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $usuarios_id = 0;


	
	protected $categorias_id = 0;


	
	protected $conf_feed_id = 0;


	
	protected $feeds_id = 0;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getUsuariosId()
	{

		return $this->usuarios_id;
	}

	
	public function getCategoriasId()
	{

		return $this->categorias_id;
	}

	
	public function getConfFeedId()
	{

		return $this->conf_feed_id;
	}

	
	public function getFeedsId()
	{

		return $this->feeds_id;
	}

	
	public function setUsuariosId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->usuarios_id !== $v || $v === 0) {
			$this->usuarios_id = $v;
			$this->modifiedColumns[] = FeedsSistemaPeer::USUARIOS_ID;
		}

	} 
	
	public function setCategoriasId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->categorias_id !== $v || $v === 0) {
			$this->categorias_id = $v;
			$this->modifiedColumns[] = FeedsSistemaPeer::CATEGORIAS_ID;
		}

	} 
	
	public function setConfFeedId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->conf_feed_id !== $v || $v === 0) {
			$this->conf_feed_id = $v;
			$this->modifiedColumns[] = FeedsSistemaPeer::CONF_FEED_ID;
		}

	} 
	
	public function setFeedsId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->feeds_id !== $v || $v === 0) {
			$this->feeds_id = $v;
			$this->modifiedColumns[] = FeedsSistemaPeer::FEEDS_ID;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->usuarios_id = $rs->getInt($startcol + 0);

			$this->categorias_id = $rs->getInt($startcol + 1);

			$this->conf_feed_id = $rs->getInt($startcol + 2);

			$this->feeds_id = $rs->getInt($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating FeedsSistema object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedsSistemaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			FeedsSistemaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedsSistemaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FeedsSistemaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += FeedsSistemaPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = FeedsSistemaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedsSistemaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getUsuariosId();
				break;
			case 1:
				return $this->getCategoriasId();
				break;
			case 2:
				return $this->getConfFeedId();
				break;
			case 3:
				return $this->getFeedsId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedsSistemaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getUsuariosId(),
			$keys[1] => $this->getCategoriasId(),
			$keys[2] => $this->getConfFeedId(),
			$keys[3] => $this->getFeedsId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedsSistemaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setUsuariosId($value);
				break;
			case 1:
				$this->setCategoriasId($value);
				break;
			case 2:
				$this->setConfFeedId($value);
				break;
			case 3:
				$this->setFeedsId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedsSistemaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setUsuariosId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setCategoriasId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConfFeedId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFeedsId($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(FeedsSistemaPeer::DATABASE_NAME);

		if ($this->isColumnModified(FeedsSistemaPeer::USUARIOS_ID)) $criteria->add(FeedsSistemaPeer::USUARIOS_ID, $this->usuarios_id);
		if ($this->isColumnModified(FeedsSistemaPeer::CATEGORIAS_ID)) $criteria->add(FeedsSistemaPeer::CATEGORIAS_ID, $this->categorias_id);
		if ($this->isColumnModified(FeedsSistemaPeer::CONF_FEED_ID)) $criteria->add(FeedsSistemaPeer::CONF_FEED_ID, $this->conf_feed_id);
		if ($this->isColumnModified(FeedsSistemaPeer::FEEDS_ID)) $criteria->add(FeedsSistemaPeer::FEEDS_ID, $this->feeds_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FeedsSistemaPeer::DATABASE_NAME);

		$criteria->add(FeedsSistemaPeer::USUARIOS_ID, $this->usuarios_id);
		$criteria->add(FeedsSistemaPeer::CATEGORIAS_ID, $this->categorias_id);
		$criteria->add(FeedsSistemaPeer::FEEDS_ID, $this->feeds_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getUsuariosId();

		$pks[1] = $this->getCategoriasId();

		$pks[2] = $this->getFeedsId();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setUsuariosId($keys[0]);

		$this->setCategoriasId($keys[1]);

		$this->setFeedsId($keys[2]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConfFeedId($this->conf_feed_id);


		$copyObj->setNew(true);

		$copyObj->setUsuariosId('null'); 
		$copyObj->setCategoriasId('null'); 
		$copyObj->setFeedsId('null'); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FeedsSistemaPeer();
		}
		return self::$peer;
	}

} 