<?php


abstract class BaseUrlVisitadasUsuario extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id_url = 0;


	
	protected $id_usuario = 0;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getIdUrl()
	{

		return $this->id_url;
	}

	
	public function getIdUsuario()
	{

		return $this->id_usuario;
	}

	
	public function setIdUrl($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_url !== $v || $v === 0) {
			$this->id_url = $v;
			$this->modifiedColumns[] = UrlVisitadasUsuarioPeer::ID_URL;
		}

	} 
	
	public function setIdUsuario($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_usuario !== $v || $v === 0) {
			$this->id_usuario = $v;
			$this->modifiedColumns[] = UrlVisitadasUsuarioPeer::ID_USUARIO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id_url = $rs->getInt($startcol + 0);

			$this->id_usuario = $rs->getInt($startcol + 1);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating UrlVisitadasUsuario object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UrlVisitadasUsuarioPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			UrlVisitadasUsuarioPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UrlVisitadasUsuarioPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UrlVisitadasUsuarioPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += UrlVisitadasUsuarioPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = UrlVisitadasUsuarioPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UrlVisitadasUsuarioPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdUrl();
				break;
			case 1:
				return $this->getIdUsuario();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UrlVisitadasUsuarioPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdUrl(),
			$keys[1] => $this->getIdUsuario(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UrlVisitadasUsuarioPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdUrl($value);
				break;
			case 1:
				$this->setIdUsuario($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UrlVisitadasUsuarioPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdUrl($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdUsuario($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(UrlVisitadasUsuarioPeer::DATABASE_NAME);

		if ($this->isColumnModified(UrlVisitadasUsuarioPeer::ID_URL)) $criteria->add(UrlVisitadasUsuarioPeer::ID_URL, $this->id_url);
		if ($this->isColumnModified(UrlVisitadasUsuarioPeer::ID_USUARIO)) $criteria->add(UrlVisitadasUsuarioPeer::ID_USUARIO, $this->id_usuario);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UrlVisitadasUsuarioPeer::DATABASE_NAME);

		$criteria->add(UrlVisitadasUsuarioPeer::ID_URL, $this->id_url);
		$criteria->add(UrlVisitadasUsuarioPeer::ID_USUARIO, $this->id_usuario);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getIdUrl();

		$pks[1] = $this->getIdUsuario();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setIdUrl($keys[0]);

		$this->setIdUsuario($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{


		$copyObj->setNew(true);

		$copyObj->setIdUrl('null'); 
		$copyObj->setIdUsuario('null'); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UrlVisitadasUsuarioPeer();
		}
		return self::$peer;
	}

} 