<?php


abstract class BaseUsuarios extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id_usuario;


	
	protected $id_conf_feed = 0;


	
	protected $password = 'null';


	
	protected $mail = 'null';


	
	protected $administrador = 0;


	
	protected $id_sesion = 0;


	
	protected $salt = 'null';


	
	protected $cultura = 'null';

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getIdUsuario()
	{

		return $this->id_usuario;
	}

	
	public function getIdConfFeed()
	{

		return $this->id_conf_feed;
	}

	
	public function getPassword()
	{

		return $this->password;
	}

	
	public function getMail()
	{

		return $this->mail;
	}

	
	public function getAdministrador()
	{

		return $this->administrador;
	}

	
	public function getIdSesion()
	{

		return $this->id_sesion;
	}

	
	public function getSalt()
	{

		return $this->salt;
	}

	
	public function getCultura()
	{

		return $this->cultura;
	}

	
	public function setIdUsuario($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_usuario !== $v) {
			$this->id_usuario = $v;
			$this->modifiedColumns[] = UsuariosPeer::ID_USUARIO;
		}

	} 
	
	public function setIdConfFeed($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_conf_feed !== $v || $v === 0) {
			$this->id_conf_feed = $v;
			$this->modifiedColumns[] = UsuariosPeer::ID_CONF_FEED;
		}

	} 
	
	public function setPassword($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->password !== $v || $v === 'null') {
			$this->password = $v;
			$this->modifiedColumns[] = UsuariosPeer::PASSWORD;
		}

	} 
	
	public function setMail($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->mail !== $v || $v === 'null') {
			$this->mail = $v;
			$this->modifiedColumns[] = UsuariosPeer::MAIL;
		}

	} 
	
	public function setAdministrador($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->administrador !== $v || $v === 0) {
			$this->administrador = $v;
			$this->modifiedColumns[] = UsuariosPeer::ADMINISTRADOR;
		}

	} 
	
	public function setIdSesion($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_sesion !== $v || $v === 0) {
			$this->id_sesion = $v;
			$this->modifiedColumns[] = UsuariosPeer::ID_SESION;
		}

	} 
	
	public function setSalt($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->salt !== $v || $v === 'null') {
			$this->salt = $v;
			$this->modifiedColumns[] = UsuariosPeer::SALT;
		}

	} 
	
	public function setCultura($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->cultura !== $v || $v === 'null') {
			$this->cultura = $v;
			$this->modifiedColumns[] = UsuariosPeer::CULTURA;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id_usuario = $rs->getInt($startcol + 0);

			$this->id_conf_feed = $rs->getInt($startcol + 1);

			$this->password = $rs->getString($startcol + 2);

			$this->mail = $rs->getString($startcol + 3);

			$this->administrador = $rs->getInt($startcol + 4);

			$this->id_sesion = $rs->getInt($startcol + 5);

			$this->salt = $rs->getString($startcol + 6);

			$this->cultura = $rs->getString($startcol + 7);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Usuarios object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UsuariosPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			UsuariosPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UsuariosPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UsuariosPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setIdUsuario($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += UsuariosPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = UsuariosPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UsuariosPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdUsuario();
				break;
			case 1:
				return $this->getIdConfFeed();
				break;
			case 2:
				return $this->getPassword();
				break;
			case 3:
				return $this->getMail();
				break;
			case 4:
				return $this->getAdministrador();
				break;
			case 5:
				return $this->getIdSesion();
				break;
			case 6:
				return $this->getSalt();
				break;
			case 7:
				return $this->getCultura();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UsuariosPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdUsuario(),
			$keys[1] => $this->getIdConfFeed(),
			$keys[2] => $this->getPassword(),
			$keys[3] => $this->getMail(),
			$keys[4] => $this->getAdministrador(),
			$keys[5] => $this->getIdSesion(),
			$keys[6] => $this->getSalt(),
			$keys[7] => $this->getCultura(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UsuariosPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdUsuario($value);
				break;
			case 1:
				$this->setIdConfFeed($value);
				break;
			case 2:
				$this->setPassword($value);
				break;
			case 3:
				$this->setMail($value);
				break;
			case 4:
				$this->setAdministrador($value);
				break;
			case 5:
				$this->setIdSesion($value);
				break;
			case 6:
				$this->setSalt($value);
				break;
			case 7:
				$this->setCultura($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UsuariosPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdUsuario($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdConfFeed($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setPassword($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setMail($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setAdministrador($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setIdSesion($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setSalt($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setCultura($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(UsuariosPeer::DATABASE_NAME);

		if ($this->isColumnModified(UsuariosPeer::ID_USUARIO)) $criteria->add(UsuariosPeer::ID_USUARIO, $this->id_usuario);
		if ($this->isColumnModified(UsuariosPeer::ID_CONF_FEED)) $criteria->add(UsuariosPeer::ID_CONF_FEED, $this->id_conf_feed);
		if ($this->isColumnModified(UsuariosPeer::PASSWORD)) $criteria->add(UsuariosPeer::PASSWORD, $this->password);
		if ($this->isColumnModified(UsuariosPeer::MAIL)) $criteria->add(UsuariosPeer::MAIL, $this->mail);
		if ($this->isColumnModified(UsuariosPeer::ADMINISTRADOR)) $criteria->add(UsuariosPeer::ADMINISTRADOR, $this->administrador);
		if ($this->isColumnModified(UsuariosPeer::ID_SESION)) $criteria->add(UsuariosPeer::ID_SESION, $this->id_sesion);
		if ($this->isColumnModified(UsuariosPeer::SALT)) $criteria->add(UsuariosPeer::SALT, $this->salt);
		if ($this->isColumnModified(UsuariosPeer::CULTURA)) $criteria->add(UsuariosPeer::CULTURA, $this->cultura);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UsuariosPeer::DATABASE_NAME);

		$criteria->add(UsuariosPeer::ID_USUARIO, $this->id_usuario);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getIdUsuario();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setIdUsuario($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdConfFeed($this->id_conf_feed);

		$copyObj->setPassword($this->password);

		$copyObj->setMail($this->mail);

		$copyObj->setAdministrador($this->administrador);

		$copyObj->setIdSesion($this->id_sesion);

		$copyObj->setSalt($this->salt);

		$copyObj->setCultura($this->cultura);


		$copyObj->setNew(true);

		$copyObj->setIdUsuario(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UsuariosPeer();
		}
		return self::$peer;
	}

} 